'Besonderheiten fuer den Editor
declare function editor_frage(frage as string) as byte
declare sub editor_leseopt(byval x as ubyte, byval y as ubyte)
declare function editor_leveltest as integer
declare sub editor_meldung(text as string)
declare sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
declare sub editor_setoptionen(byval set as string)
declare sub testspiel

const EDITOR_STEINBREITE = 20, EDITOR_LEVELBREITE = 32
const EDITOR_STEINHOEHE  = 20, EDITOR_LEVELHOEHE  = 20
const EDITOR_LVLBPLUS = 0, EDITOR_LVLHPLUS = 4
const EDITOR_LEVELPFAD = "level/", EDITOR_EBENEN = 1
const EDITOR_ZEITMIN = 20, EDITOR_ZEITMAX = 995, EDITOR_ZEITSTEP = 5
const EDITOR_WINTITEL = "Laser-Editor"
dim shared as ushort editorfeld(0 to 33, 0 to 25, 0)
for i as ubyte = 1 to 6
  editorfeld(i, 1, 0) = i-1
next
for i as ubyte = 1 to 32
  editorfeld(i, 2, 0) = i+10
next

#include "editor004.inc"

function editor_frage(frage as string) as byte
  dim antwort as string, speicher as any ptr = bildschirm_speichern
  _MODUS_ -= 10
  meldung frage
  _MODUS_ += 10
  do
    antwort = lcase(inkey)
    sleep 1
  loop until antwort = "j" or antwort = "y" or antwort = "n" or antwort = chr(27)
  bildschirm_zuruecksetzen(speicher)
  if antwort = "n" or antwort = chr(27) then return 0 else return -1
end function

sub editor_leseopt(byval x as ubyte, byval y as ubyte)
  ' gibt den aktuellen Optionswert auf dem Bildschirm aus
  color &hffffff
  locate 1, 66
  print "Drehung: " & (editorfeld(x, y, 0) shr 8) & "   "
end sub

function editor_leveltest as integer
  dim as integer laser = 0, spieler1 = 0, spieler2 = 0, reserve1 = 0, reserve2 = 0
  dim as string fehler = ""
  for x as integer = 1 to 32
    for y as integer = 5 to 24
      select case editorfeld(x, y, 0)
        case 1 to 4 : laser += 1
        case 5 : spieler1 += 1
        case 6 : spieler2 += 1
        case 8 : reserve1 += 1
        case 9 : reserve2 += 1
      end select
    next
  next
  if laser = 0 then fehler = "Fehler: Das Level\nenthaelt keine Laser!"
  if spieler1 = 0 then fehler = "Fehler: Das Spiel muss ein\ngruenes Maennchen enthalten!"
  if spieler1 > 1 then fehler = "Fehler: Das Spiel darf nur ein\ngruenes Maennchen enthalten!"
  if typ = 1 then
    if spieler2 > 0 then fehler = "Fehler: Ein Einzelspiel darf\nkein blaues Maennchen enthalten!"
  else
    if spieler2 = 0 then fehler = "Fehler: Das Spiel muss ein\nblaues Maennchen enthalten!"
    if spieler2 > 1 then fehler = "Fehler: Das Spiel darf nur ein\nblaues Maennchen enthalten!"
  end if
  if typ <> 3 then
    if reserve1 > 0 or reserve2 > 0 then _
       fehler = "Fehler: Nur im Schlacht-Modus duerfen\nReservemaennchen verwendet werden!"
  end if
  if reserve1 >= menschMax or reserve2 >= menschMax then _
     fehler = "Fehler: Im Schlacht-Modus duerfen nur bis zu\n" & (menschMax-1) & " Reservemaennchen verwendet werden!"
  if fehler = "" then return -1
  dim as any ptr bild = bildschirm_speichern
  meldung fehler
  getkey
  bildschirm_zuruecksetzen bild
  return 0
end function

sub editor_meldung(text as string)
  dim taste as string, speicher as any ptr = bildschirm_speichern
  _MODUS_ -= 10
  meldung text
  _MODUS_ += 10
  do : sleep 1 : loop until inkey = " "
  bildschirm_zuruecksetzen(speicher)
end sub

sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
  ' setzt den Optionswert hoeher (wert=1) oder tiefer (wert=-1)
  if spiegel(editorfeld(x, y, 0) and 255).naechster = editorfeld(x, y, 0) and 255 _
     and spiegel(editorfeld(x, y, 0) and 255).dreh <> 3 then exit sub
  dim aktuell as ubyte
  aktuell = editorfeld(x, y, 0) shr 8
  if wert = 1 and aktuell < 99 then editorfeld(x, y, 0) = (editorfeld(x, y, 0) and 255) + (aktuell+1)*256
  if wert = -1 and aktuell > 0 then editorfeld(x, y, 0) = (editorfeld(x, y, 0) and 255) + (aktuell-1)*256
  editor_leseopt(x, y)
  stein x, y, editorfeld(x, y, 0)
end sub

sub editor_setoptionen(byval set as string)
  dim speicher as any ptr
  dim as string eingabe, major, minor
  speicher = bildschirm_speichern
  cls
  ladeinfo(set, typ, kommentar, autor, version)
  major = str(version\1000)
  minor = str(version mod 1000)
  if typ = 0 then typ = 1
  locate 1, 1
  print "Einstellungen fuer das Set " & set
  eingabe = inputt(3, 1, "Autor: ", string(63, 42), autor)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe <> chr(27) then autor = eingabe
  eingabe = inputt(4, 1, "Majorrelease: ", "00", major)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe = chr(27) and val(eingabe) < 64 then
    version = val(major)*1000
  else
    version = val(eingabe)*1000
  end if
  eingabe = inputt(5, 1, "Minorrelease: ", "000", minor)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe = chr(27) then
    version += val(minor)
  else
    version += val(eingabe)
  end if
  locate 6, 1
  print "Levelart: (1) Einzelspiel; (2) Partnerspiel; (3) Schlachtmodus"
  eingabe = input(1)
  if val(eingabe) > 0 and val(eingabe) < 4 then typ = val(eingabe)
  select case typ
    case 1
      print "-> Einzelspiel"
      editorfeld(7, 1, 0) = 0
      editorfeld(8, 1, 0) = 0
      editorfeld(9, 1, 0) = 0
    case 2
      print "-> Partnerspiel"
      editorfeld(7, 1, 0) = 6
      editorfeld(8, 1, 0) = 0
      editorfeld(9, 1, 0) = 0
    case 3
      print "-> Schlachtmodus"
      editorfeld(7, 1, 0) = 6
      editorfeld(8, 1, 0) = 8
      editorfeld(9, 1, 0) = 9
  end select
  locate 9, 1
  print "bisheriger Kommentar:"
  print kommentar
  print
  print "neuer Kommentar (max. 255 Zeichen; Leereingabe uebernimmt den alten Kommentar):"
  line input eingabe
  if eingabe <> "" then kommentar = left(eingabe, 255)
  speichereinfo(set, typ, kommentar, autor, version)
  cls
  bildschirm_zuruecksetzen(speicher)
  for i as integer = 7 to 9
    feld(i, 1) = editorfeld(i, 1, 0)
    stein i, 1
  next
end sub

sub testspiel
  dim speicher as any ptr, ergebnis as TypSpielergebnis
  _MODUS_ = 10
  mensch(1).punkte = 0
  speicher = bildschirm_speichern
  speichern "temp", 0
  ergebnis = spiel("temp", 0)
  cls
  bildschirm_zuruecksetzen speicher
  laden "temp", 0
  kill "level/temp"
  for i as ubyte = 1 to 32
    feld(i, 1) = editorfeld(i, 1, 0)
    feld(i, 2) = editorfeld(i, 2, 0)
  next
  _MODUS_ = 1
  color &hffffff
end sub
